



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ZooKeeper和CAP理论及一致性原则</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ZooKeeper和CAP理论及一致性原则</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 05:56:19 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一、CAP理论概述<br />CAP理论告诉我们，一个分布式系统不可能同时满足以下三种</p>
<p>一致性（C:Consistency）<br />可用性（A:Available）<br />分区容错性（P:Partition Tolerance）<br />这三个基本需求，最多只能同时满足其中的两项，因为P是必须的,因此往往选择就在CP或者AP中。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/523400/201904/523400-20190414110948105-926530311.png" /></p>
<p>一致性（C:Consistency）<br />在分布式环境中，一致性是指数据在多个副本之间是否能够保持数据一致的特性。在一致性的需求下，当一个系统在数据一致的状态下执行更新操作后，应该保证系统的数据仍然处于一致的状态。例如一个将数据副本分布在不同分布式节点上的系统来说，如果对第一个节点的数据进行了更新操作并且更新成功后，其他节点上的数据也应该得到更新，并且所有用户都可以读取到其最新的值，那么这样的系统就被认为具有强一致性（或严格的一致性，最终一致性）。</p>
<p>可用性（A:Available）<br />可用性是指系统提供的服务必须一直处于可用的状态，对于用户的每一个操作请求总是能够在有限的时间内返回结果。&ldquo;有效的时间内&rdquo;是指，对于用户的一个操作请求，系统必须能够在指定的时间（即响应时间）内返回对应的处理结果，如果超过了这个时间范围，那么系统就被认为是不可用的。</p>
<p>&ldquo;返回结果&rdquo;是可用性的另一个非常重要的指标，它要求系统在完成对用户请求的处理后，返回一个正常的响应结果。正常的响应结果通常能够明确的反映出对请求的处理结果，即成功或失败，而不是一个让用户感到困惑的返回结果。</p>
<p>分区容错性（P:Partition Tolerance）<br />分区容错性约束了一个分布式系统需要具有如下特性：分布式系统在遇到任何网络分区故障的时候，仍然需要能够保证对外提供满足一致性和可用性的服务，除非是整个网络环境都发生了故障。</p>
<p>网络分区是指在分布式系统中，不同的节点分布在不同的子网络（机房或异地网络等）中，由于一些特殊的原因导致这些子网络之间出现网络不连通的状况，但各个子网络的内部网络是正常的，从而导致整个系统的网络环境被切分成了若干个孤立的区域。需要注意的是，组成一个分布式系统的每个节点的加入与退出都可以看作是一个特殊的网络分区。</p>
<p>由于一个分布式系统无法同时满足上面的三个需求，而只能满足其中的两项，因此在进行对CAP定理的应用的时候，需要根据业务的要求抛弃其中的一项，下表所示是抛弃CAP定理中任意一项特性的场景说明。</p>
<p>因此，将精力浪费在思考如何设计能满足三者的完美系统上是愚钝的，应该根据应用场景进行适当取舍。</p>
<p>二、一致性的分类<br />一致性是指从系统外部读取系统内部的数据时，在一定约束条件下相同，即数据变动在系统内部各节点应该是同步的。根据一致性的强弱程度不同，可以将一致性的分类为如下几种：</p>
<p>强一致性：（strong consistency）。任何时刻，任何用户都能读取到最近一次成功更新的数据。</p>
<p>单调一致性：（monotonic consistency）。任何时刻，任何用户一旦读到某个数据在某次更新后的值，那么就不会再读到比这个值更旧的值。也就是说，可获取的数据顺序必是单调递增的。</p>
<p>会话一致性：（session consistency）。任何用户在某次会话中，一旦读到某个数据在某次更新后的值，那么在本次会话中就不会再读到比这值更旧的值，会话一致性是在单调一致性的基础上进一步放松约束，只保证单个用户单个会话内的单调性，在不同用户或同一用户不同会话间则没有保障。</p>
<p>最终一致性：（eventual consistency）。用户只能读到某次更新后的值，但系统保证数据将最终达到完全一致的状态，只是所需时间不能保障。</p>
<p>弱一致性：（weak consistency）。用户无法在确定时间内读到最新更新的值。</p>
<p>三、ZooKeeper提供的一致性服务<br />ZooKeeper从以下几点保证了数据的一致性</p>
<p>顺序一致性：来自任意特定客户端的更新都会按其发送顺序被提交保持一致。也就是说，如果一个客户端将Znode z的值更新为a，在之后的操作中，它又将z的值更新为b，则没有客户端能够在看到z的值是b之后再看到值a（如果没有其他对z的更新）。</p>
<p>原子性：每个更新要么成功，要么失败。这意味着如果一个更新失败，则不会有客户端会看到这个更新的结果。</p>
<p>单一系统映像：一个客户端无论连接到哪一台服务器，它看到的都是同样的系统视图。这意味着，如果一个客户端在同一个会话中连接到一台新的服务器，它所看到的系统状态不会比 在之前服务器上所看到的更老。当一台服务器出现故障，导致它的一个客户端需要尝试连接集合体中其他的服务器时，所有滞后于故障服务器的服务器都不会接受该 连接请求，除非这些服务器赶上故障服务器。</p>
<p>持久性：一个更新一旦成功，其结果就会持久存在并且不会被撤销。这表明更新不会受到服务器故障的影响。</p>
<p>实时性：在特定的一段时间内，客户端看到的系统需要被保证是实时的（在十几秒的时间里）。在此时间段内，任何系统的改变将被客户端看到，或者被客户端侦测到。</p>
<p>四、用CAP理论来分析ZooKeeper<br />CAP理论告诉我们，一个分布式系统不可能同时满足以下三种</p>
<p>一致性（C:Consistency）<br />可用性（A:Available）<br />分区容错性（P:Partition Tolerance）<br />这三个基本需求，最多只能同时满足其中的两项，因为P是必须的,因此往往选择就在CP或者AP中。</p>
<p>在此ZooKeeper保证的是CP</p>
<p>分析：可用性（A:Available）</p>
<p>不能保证每次服务请求的可用性。任何时刻对ZooKeeper的访问请求能得到一致的数据结果，同时系统对网络分割具备容错性；但是它不能保证每次服务请求的可用性（注：也就是在极端环境下，ZooKeeper可能会丢弃一些请求，消费者程序需要重新请求才能获得结果）。所以说，ZooKeeper不能保证服务可用性。</p>
<p>进行leader选举时集群都是不可用。在使用ZooKeeper获取服务列表时，当master节点因为网络故障与其他节点失去联系时，剩余节点会重新进行leader选举。问题在于，选举leader的时间太长，30 ~ 120s, 且选举期间整个zk集群都是不可用的，这就导致在选举期间注册服务瘫痪，虽然服务能够最终恢复，但是漫长的选举时间导致的注册长期不可用是不能容忍的。所以说，ZooKeeper不能保证服务可用性。</p>
<p>参考：https://www.cnblogs.com/xrq730/p/4944768.html</p>
<p>参考：https://blog.csdn.net/xiangxizhishi/article/details/78469027</p>
<p>Contact<br />作者：鹏磊<br />出处：http://www.ymq.io/2018/05/18/zookeeper<br />版权归作者所有，转载请注明出处<br />Wechat：关注公众号，搜云库，专注于开发技术的研究与知识分享</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/523400/201904/523400-20190414111016974-36688249.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gjr097.html">Xamarin与Visual stuido2015离线安装包分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mjge28.html">C&num;-和时间有关的计算代码、时间相减 得到天数、小时、分钟、秒差</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw00zy9.html">Yii2使用教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7dr51q.html">Oracle存储过程记录异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy7nygq.html">highcharts 使用实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qypxldq.html">ARP协议和DNS协议对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okknkl9.html">Checking For User Permissions Before Updating or Inserting The Records in Oracle Forms</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xwne09.html">&lbrack;dts&rsqb;Device Tree机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zv3v59.html">单行bash、shell、perl命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1r0yk9.html">120&period; Triangle</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2we1n3q.html">&lbrack;学习笔记&rsqb;设计模式之Facade</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m6ooxq.html">Velocity浅析及与Jsp、Freemarker对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd73lr8.html">ThinkPHP第十三天&lpar;CONF&lowbar;PATH、APP&lowbar;PATH，UEditor用法&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg50478.html">Android自动化测试框架新书&colon;交流</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdxpn49.html">NSKeyedArchiver&sol;NSKeyedUnarchiver归档应用（缓存实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1jr11q.html">Python Keras module &amp;&num;39&semi;keras&period;backend&amp;&num;39&semi; has no attribute &amp;&num;39&semi;image&lowbar;data&lowbar;format&amp;&num;39&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwdzx9.html">JSTL常用标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj1yj59.html">centos 7刚安装后无法联网解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1glopq.html">javaScript系列 &lbrack;03&rsqb;-javaScript原型对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvnoxy8.html">Python&mdash;迭代器与生成器</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pw7w578.html">构建工具build tools</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r42nm9.html">使用VMware新建一个Linux系统虚拟机（全）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjzdj49.html">演示stop暴力停止线程导致数据不一致的问题，但是有些有趣的发现 &lpar;2017-07-03 21&colon;25&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2jrmy9.html">JVM虚拟机  YGC和FGC发生的具体场景</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvgg628.html">剑指Offer 21&period; 栈的压入、弹出序列 （栈）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o133z1q.html">echarts背景分割区域填充不同颜色&lpar;x轴为time&rpar;，实时刷新</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvnn638.html">5&period;移动终端App测试点归纳</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd6x2z9.html">LCA - Tarjan 算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o13oreq.html">解决eclipse高版本JDK编译的项目到低版本JDK服务器上不能运行的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvgk3g8.html">【mongodb】如何在mac上安装mongoDB</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
